diff --git a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandBiome.java b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandBiome.java
index 13864118b..8d1d33804 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandBiome.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandBiome.java
@@ -9,7 +9,6 @@ import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.arguments.ArgumentTypeBiome;
@@ -17,75 +16,76 @@ import net.minecraft.core.net.command.arguments.ArgumentTypeIntegerCoordinates;
 import net.minecraft.core.net.command.helpers.Coordinates2D;
 import net.minecraft.core.net.command.helpers.IntegerCoordinates;
 import net.minecraft.core.world.chunk.Chunk;
-import net.minecraft.core.world.chunk.ChunkSection;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.joml.Vector3dc;
 
 public class CommandBiome implements CommandManager.CommandRegistry {
     private static final DynamicCommandExceptionType FAILURE = new DynamicCommandExceptionType(arg -> () -> I18n.getInstance().translateKeyAndFormat("command.commands.biome.locate.exception_failure", arg));
 
     public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register(ArgumentBuilderLiteral.<CommandSource>literal("biome")
-                .requires(CommandSource::hasAdmin)
-                .then(ArgumentBuilderLiteral.<CommandSource>literal("set")
-                    .then(ArgumentBuilderRequired.<CommandSource, Biome>argument("biome", ArgumentTypeBiome.biome())
-                        .executes(c -> {
-                            Biome biome = c.getArgument("biome", Biome.class);
-                            c.getSource().sendMessage(biome.translationKey);
-                            Vec3 coords = c.getSource().getCoordinates(false);
-                            if (coords != null) {
-                                Chunk chunk = c.getSource().getWorld().getChunkFromBlockCoords(MathHelper.floor(coords.x), MathHelper.floor(coords.z));
-                                for (int s = 0; s < Chunk.CHUNK_SECTIONS; s++) {
-                                    chunk.getSection(s).setSectionBiome(biome);
-                                }
+            .requires(CommandSource::hasAdmin)
+            .then(ArgumentBuilderLiteral.<CommandSource>literal("set")
+                .then(ArgumentBuilderRequired.<CommandSource, Biome>argument("biome", ArgumentTypeBiome.biome())
+                    .executes(c -> {
+                        Biome biome = c.getArgument("biome", Biome.class);
+                        c.getSource().sendMessage(biome.translationKey);
+                        Vector3dc coords = c.getSource().getCoordinates(false);
+                        if (coords != null) {
+                            Chunk chunk = c.getSource().getWorld().getChunkFromBlockCoords(MathHelper.floor(coords.x()), MathHelper.floor(coords.z()));
+                            for (int s = 0; s < Chunk.CHUNK_SECTIONS; s++) {
+                                chunk.getSection(s).setSectionBiome(biome);
                             }
-                            return Command.SINGLE_SUCCESS;
-                        })))
-                .then(ArgumentBuilderLiteral.<CommandSource>literal("get")
-                        .then(ArgumentBuilderRequired.<CommandSource, IntegerCoordinates>argument("position", ArgumentTypeIntegerCoordinates.intCoordinates())
-                                .executes(c -> {
-                                    IntegerCoordinates position = c.getArgument("position", IntegerCoordinates.class);
-                                    Biome biome = c.getSource().getWorld().getBlockBiome(position.getX(c.getSource()), position.getY(c.getSource(), true), position.getZ(c.getSource()));
-                                    c.getSource().sendTranslatableMessage("command.commands.biome.get.success", position.getX(c.getSource()), position.getY(c.getSource(), true), position.getZ(c.getSource()), Registries.BIOMES.getKey(biome));
-                                    return Command.SINGLE_SUCCESS;
-                                })))
-                .then(ArgumentBuilderLiteral.<CommandSource>literal("locate")
-                        .then(ArgumentBuilderRequired.<CommandSource, Biome>argument("biome", ArgumentTypeBiome.biome())
-                                .executes(c -> {
-                                    Biome biome = c.getArgument("biome", Biome.class);
-                                    Coordinates2D biomeLocation = getBiomeCoords(biome, c.getSource());
-                                    if (biomeLocation == null) throw FAILURE.create(Registries.BIOMES.getKey(biome));
-                                    Vec3 sourcePos = c.getSource().getBlockCoordinates();
-                                    if (sourcePos == null) {
-                                        c.getSource().sendTranslatableMessage("command.commands.biome.locate.success", Registries.BIOMES.getKey(biome), biomeLocation.getX(c.getSource()), biomeLocation.getZ(c.getSource()));
-                                    } else {
-                                        int distance = (int)sourcePos.distanceTo(Vec3.fromPool(biomeLocation.getX(c.getSource()), sourcePos.y, biomeLocation.getZ(c.getSource())));
-                                        c.getSource().sendTranslatableMessage(distance == 1 ? "command.commands.biome.locate.success_in_world_single" : "command.commands.biome.locate.success_in_world_multiple", Registries.BIOMES.getKey(biome), biomeLocation.getX(c.getSource()), biomeLocation.getZ(c.getSource()), distance);
-                                    }
-                                    return Command.SINGLE_SUCCESS;
-                                }))));
+                        }
+                        return Command.SINGLE_SUCCESS;
+                    })))
+            .then(ArgumentBuilderLiteral.<CommandSource>literal("get")
+                .then(ArgumentBuilderRequired.<CommandSource, IntegerCoordinates>argument("position", ArgumentTypeIntegerCoordinates.intCoordinates())
+                    .executes(c -> {
+                        IntegerCoordinates position = c.getArgument("position", IntegerCoordinates.class);
+                        Biome biome = c.getSource().getWorld().getBlockBiome(position.getX(c.getSource()), position.getY(c.getSource(), true), position.getZ(c.getSource()));
+                        c.getSource().sendTranslatableMessage("command.commands.biome.get.success", position.getX(c.getSource()), position.getY(c.getSource(), true), position.getZ(c.getSource()), Registries.BIOMES.getKey(biome));
+                        return Command.SINGLE_SUCCESS;
+                    })))
+            .then(ArgumentBuilderLiteral.<CommandSource>literal("locate")
+                .then(ArgumentBuilderRequired.<CommandSource, Biome>argument("biome", ArgumentTypeBiome.biome())
+                    .executes(c -> {
+                        Biome biome = c.getArgument("biome", Biome.class);
+                        Coordinates2D biomeLocation = getBiomeCoords(biome, c.getSource());
+                        if (biomeLocation == null) throw FAILURE.create(Registries.BIOMES.getKey(biome));
+                        TilePosc sourcePos = c.getSource().getBlockCoordinates();
+                        if (sourcePos == null) {
+                            c.getSource().sendTranslatableMessage("command.commands.biome.locate.success", Registries.BIOMES.getKey(biome), biomeLocation.getX(c.getSource()), biomeLocation.getZ(c.getSource()));
+                        } else {
+                            int distance = (int) sourcePos.distance(biomeLocation.getX(c.getSource()), sourcePos.y(), biomeLocation.getZ(c.getSource()));
+                            c.getSource().sendTranslatableMessage(distance == 1 ? "command.commands.biome.locate.success_in_world_single" : "command.commands.biome.locate.success_in_world_multiple", Registries.BIOMES.getKey(biome), biomeLocation.getX(c.getSource()), biomeLocation.getZ(c.getSource()), distance);
+                        }
+                        return Command.SINGLE_SUCCESS;
+                    }))));
     }
 
     private static Coordinates2D getBiomeCoords(Biome biome, CommandSource source) {
         int[] xPattern = new int[]{0, 1, 0, -1};
         int[] zPattern = new int[]{1, 0, -1, 0};
-        Vec3 sourcePos = source.getBlockCoordinates();
-        if (sourcePos == null) sourcePos = Vec3.fromPool(0.0, 0.0, 0.0);
+        TilePosc sourcePos = source.getBlockCoordinates();
+        if (sourcePos == null) sourcePos = new TilePos(0, 0, 0);
         int runLength = 2;
-        int chunkX = (int)(sourcePos.x / 16.0);
-        int y = (int)sourcePos.y;
-        int chunkZ = (int)(sourcePos.z / 16.0);
+        int chunkX = (int) (sourcePos.x() / 16.0);
+        int chunkZ = (int) (sourcePos.z() / 16.0);
         int passes = 1024;
-        if (source.getWorld().getBlockBiome((int)sourcePos.x, y, (int)sourcePos.z) == biome) {
-            return new Coordinates2D((int)sourcePos.x, (int)sourcePos.z);
+        if (source.getWorld().getBlockBiome(sourcePos) == biome) {
+            return new Coordinates2D(sourcePos.x(), sourcePos.z());
         } else {
             --chunkX;
             --chunkZ;
 
-            for(int pass = 0; pass < passes; ++pass) {
-                for(int i = 0; i < 4; ++i) {
-                    for(int j = runLength - 1; j >= 0; --j) {
+            for (int pass = 0; pass < passes; ++pass) {
+                for (int i = 0; i < 4; ++i) {
+                    for (int j = runLength - 1; j >= 0; --j) {
                         chunkX += xPattern[i];
                         chunkZ += zPattern[i];
-                        if (source.getWorld().getBlockBiome(chunkX * 16, y, chunkZ * 16) == biome) {
+                        if (source.getWorld().getBlockBiome(new TilePos(chunkX * 16, sourcePos.y(), chunkZ * 16)) == biome) {
                             return new Coordinates2D(chunkX * 16, chunkZ * 16);
                         }
                     }
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandClone.java b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandClone.java
index bdc85300d..3e0bd646d 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandClone.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandClone.java
@@ -12,8 +12,6 @@ import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.util.CommandHelper;
-import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.net.command.CommandSource;
@@ -25,6 +23,8 @@ import net.minecraft.core.net.command.helpers.ClonedBlock;
 import net.minecraft.core.net.command.helpers.IntegerCoordinate;
 import net.minecraft.core.net.command.helpers.IntegerCoordinates;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3d;
+import org.joml.primitives.AABBd;
 
 import java.util.HashMap;
 import java.util.Map;
@@ -141,7 +141,7 @@ public class CommandClone implements CommandManager.CommandRegistry {
         int destinationY = destination.getPosition().getY(source, true);
         int destinationZ = destination.getPosition().getZ(source);
 
-        if (cloneMode == CloneMode.NORMAL && AABB.fromPool(minX, minY, minZ, maxX, maxY, maxZ).contains(Vec3.fromPool(destinationX, destinationY, destinationZ)) && start.getWorld() == destination.getWorld()) {
+        if (cloneMode == CloneMode.NORMAL && new AABBd(minX, minY, minZ, maxX, maxY, maxZ).containsPoint(new Vector3d(destinationX, destinationY, destinationZ)) && start.getWorld() == destination.getWorld()) {
             throw INSIDE_CLONED_AREA.create();
         }
 
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandParticle.java b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandParticle.java
index ae05993a8..d3f132569 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandParticle.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandParticle.java
@@ -12,7 +12,7 @@ import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.arguments.ArgumentTypeEntity;
 import net.minecraft.core.net.command.arguments.ArgumentTypeParticleId;
-import net.minecraft.core.net.command.arguments.ArgumentTypeVec3;
+import net.minecraft.core.net.command.arguments.ArgumentTypeVector3d;
 import net.minecraft.core.net.command.helpers.DoubleCoordinates;
 import net.minecraft.core.net.command.helpers.EntitySelector;
 import org.jetbrains.annotations.Nullable;
@@ -34,7 +34,7 @@ public class CommandParticle implements CommandManager.CommandRegistry {
                             }
                             return Command.SINGLE_SUCCESS;
                         })
-                        .then(ArgumentBuilderRequired.<CommandSource, DoubleCoordinates>argument("position", ArgumentTypeVec3.vec3d())
+                        .then(ArgumentBuilderRequired.<CommandSource, DoubleCoordinates>argument("position", ArgumentTypeVector3d.vec3d())
                             .executes(c -> {
                                 String particleId = c.getArgument("particleId", String.class);
                                 DoubleCoordinates pos = c.getArgument("position", DoubleCoordinates.class);
@@ -42,7 +42,7 @@ public class CommandParticle implements CommandManager.CommandRegistry {
 
                                 return Command.SINGLE_SUCCESS;
                             })
-                            .then(ArgumentBuilderRequired.<CommandSource, DoubleCoordinates>argument("motion", ArgumentTypeVec3.vec3d())
+                            .then(ArgumentBuilderRequired.<CommandSource, DoubleCoordinates>argument("motion", ArgumentTypeVector3d.vec3d())
                                 .executes(c -> {
                                     String particleId = c.getArgument("particleId", String.class);
                                     DoubleCoordinates pos = c.getArgument("position", DoubleCoordinates.class);
@@ -92,7 +92,7 @@ public class CommandParticle implements CommandManager.CommandRegistry {
 
                                 return Command.SINGLE_SUCCESS;
                             })
-                            .then(ArgumentBuilderRequired.<CommandSource, DoubleCoordinates>argument("motion", ArgumentTypeVec3.vec3d())
+                            .then(ArgumentBuilderRequired.<CommandSource, DoubleCoordinates>argument("motion", ArgumentTypeVector3d.vec3d())
                                 .executes(c -> {
                                     String particleId = c.getArgument("particleId", String.class);
                                     DoubleCoordinates motion = c.getArgument("motion", DoubleCoordinates.class);
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandPlaySound.java b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandPlaySound.java
index 6dbc18a24..531a202b3 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandPlaySound.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandPlaySound.java
@@ -12,12 +12,12 @@ import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.arguments.ArgumentTypeEntity;
 import net.minecraft.core.net.command.arguments.ArgumentTypeSoundCategory;
 import net.minecraft.core.net.command.arguments.ArgumentTypeSoundId;
-import net.minecraft.core.net.command.arguments.ArgumentTypeVec3;
+import net.minecraft.core.net.command.arguments.ArgumentTypeVector3d;
 import net.minecraft.core.net.command.helpers.DoubleCoordinates;
 import net.minecraft.core.net.command.helpers.EntitySelector;
 import net.minecraft.core.sound.SoundCategory;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
+import org.joml.Vector3dc;
 
 import java.util.List;
 
@@ -40,16 +40,16 @@ public class CommandPlaySound implements CommandManager.CommandRegistry {
                                 }
                                 return 0;
                             })
-                            .then(ArgumentBuilderRequired.<CommandSource, DoubleCoordinates>argument("position", ArgumentTypeVec3.vec3d())
+                            .then(ArgumentBuilderRequired.<CommandSource, DoubleCoordinates>argument("position", ArgumentTypeVector3d.vec3d())
                                 .executes(c -> {
                                     String soundId = c.getArgument("soundId", String.class);
                                     SoundCategory category = c.getArgument("type", SoundCategory.class);
                                     DoubleCoordinates coordinates = c.getArgument("position", DoubleCoordinates.class);
 
-                                    Vec3 coords = c.getSource().getCoordinates(true);
-                                    double sourceX = coords == null ? 0 : coords.x;
-                                    double sourceY = coords == null ? 0 : coords.y;
-                                    double sourceZ = coords == null ? 0 : coords.z;
+                                    Vector3dc coords = c.getSource().getCoordinates(true);
+                                    double sourceX = coords == null ? 0 : coords.x();
+                                    double sourceY = coords == null ? 0 : coords.y();
+                                    double sourceZ = coords == null ? 0 : coords.z();
                                     World world = c.getSource().getWorld();
                                     world.playSoundEffect(null, category, coordinates.getX(sourceX), coordinates.getY(sourceY), coordinates.getZ(sourceZ), soundId, 1f, 1f);
                                     return Command.SINGLE_SUCCESS;
@@ -61,10 +61,10 @@ public class CommandPlaySound implements CommandManager.CommandRegistry {
                                         DoubleCoordinates coordinates = c.getArgument("position", DoubleCoordinates.class);
                                         float volume = c.getArgument("volume", Float.class);
 
-                                        Vec3 coords = c.getSource().getCoordinates(true);
-                                        double sourceX = coords == null ? 0 : coords.x;
-                                        double sourceY = coords == null ? 0 : coords.y;
-                                        double sourceZ = coords == null ? 0 : coords.z;
+                                        Vector3dc coords = c.getSource().getCoordinates(true);
+                                        double sourceX = coords == null ? 0 : coords.x();
+                                        double sourceY = coords == null ? 0 : coords.y();
+                                        double sourceZ = coords == null ? 0 : coords.z();
                                         World world = c.getSource().getWorld();
                                         world.playSoundEffect(null, category, coordinates.getX(sourceX), coordinates.getY(sourceY), coordinates.getZ(sourceZ), soundId, volume, 1f);
                                         return Command.SINGLE_SUCCESS;
@@ -77,10 +77,10 @@ public class CommandPlaySound implements CommandManager.CommandRegistry {
                                             float volume = c.getArgument("volume", Float.class);
                                             float pitch = c.getArgument("pitch", Float.class);
 
-                                            Vec3 coords = c.getSource().getCoordinates(true);
-                                            double sourceX = coords == null ? 0 : coords.x;
-                                            double sourceY = coords == null ? 0 : coords.y;
-                                            double sourceZ = coords == null ? 0 : coords.z;
+                                            Vector3dc coords = c.getSource().getCoordinates(true);
+                                            double sourceX = coords == null ? 0 : coords.x();
+                                            double sourceY = coords == null ? 0 : coords.y();
+                                            double sourceZ = coords == null ? 0 : coords.z();
                                             World world = c.getSource().getWorld();
                                             world.playSoundEffect(null, category, coordinates.getX(sourceX), coordinates.getY(sourceY), coordinates.getZ(sourceZ), soundId, volume, pitch);
                                             return Command.SINGLE_SUCCESS;
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandSummon.java b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandSummon.java
index 895f529c8..1197ab87a 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandSummon.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandSummon.java
@@ -9,14 +9,13 @@ import com.mojang.brigadier.context.CommandContext;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.net.command.CommandManager;
-import net.minecraft.core.util.phys.Vec3;
-import net.minecraft.core.world.World;
 import net.minecraft.core.net.command.util.CommandHelper;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.arguments.ArgumentTypeEntitySummon;
-import net.minecraft.core.net.command.arguments.ArgumentTypeVec3;
+import net.minecraft.core.net.command.arguments.ArgumentTypeVector3d;
 import net.minecraft.core.net.command.exceptions.CommandExceptions;
 import net.minecraft.core.net.command.helpers.DoubleCoordinates;
+import org.joml.Vector3dc;
 
 public class CommandSummon implements CommandManager.CommandRegistry {
     public void register(CommandDispatcher<CommandSource> dispatcher) {
@@ -25,16 +24,16 @@ public class CommandSummon implements CommandManager.CommandRegistry {
                 .then(ArgumentBuilderRequired.<CommandSource, Class<? extends Entity>>argument("entity", ArgumentTypeEntitySummon.entity())
                         .executes(c -> {
                             CommandSource source = c.getSource();
-                            Vec3 coordinates = source.getCoordinates(false);
+                            Vector3dc coordinates = source.getCoordinates(false);
                             if (source.getSender() == null || coordinates == null) throw CommandExceptions.notInWorld().create();
 
-                            Entity entity = summonEntityAt(c, coordinates.x, coordinates.y - source.getSender().heightOffset, coordinates.z, 0.0f, 0.0f);
+                            Entity entity = summonEntityAt(c, coordinates.x(), coordinates.y() - source.getSender().heightOffset, coordinates.z(), 0.0f, 0.0f);
 
                             source.sendTranslatableMessage("command.commands.summon.success_single_entity", CommandHelper.getEntityName(entity));
 
                             return Command.SINGLE_SUCCESS;
                         })
-                        .then(ArgumentBuilderRequired.<CommandSource, DoubleCoordinates>argument("position", ArgumentTypeVec3.vec3d())
+                        .then(ArgumentBuilderRequired.<CommandSource, DoubleCoordinates>argument("position", ArgumentTypeVector3d.vec3d())
                                 .executes(c -> {
                                     CommandSource source = c.getSource();
                                     DoubleCoordinates coordinates = c.getArgument("position", DoubleCoordinates.class);
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandTeleport.java b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandTeleport.java
index 20bfd5712..d1f1e7ad8 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandTeleport.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/commands/CommandTeleport.java
@@ -12,12 +12,11 @@ import net.minecraft.core.net.command.arguments.ArgumentTypeDimension;
 import net.minecraft.core.net.command.util.CommandHelper;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.arguments.ArgumentTypeEntity;
-import net.minecraft.core.net.command.arguments.ArgumentTypeVec3;
+import net.minecraft.core.net.command.arguments.ArgumentTypeVector3d;
 import net.minecraft.core.net.command.exceptions.CommandExceptions;
 import net.minecraft.core.net.command.helpers.DoubleCoordinates;
 import net.minecraft.core.net.command.helpers.EntitySelector;
 import net.minecraft.core.world.Dimension;
-import net.minecraft.core.world.PortalHandler;
 
 import java.util.List;
 
@@ -26,7 +25,7 @@ public class CommandTeleport implements CommandManager.CommandRegistry {
         CommandNode<CommandSource> command = dispatcher.register(ArgumentBuilderLiteral.<CommandSource>literal("teleport")
                 .requires(CommandSource::hasAdmin)
                 .then(ArgumentBuilderRequired.<CommandSource, Dimension>argument("dimension", ArgumentTypeDimension.dimension())
-                    .then(ArgumentBuilderRequired.<CommandSource, DoubleCoordinates>argument("position", ArgumentTypeVec3.vec3d())
+                    .then(ArgumentBuilderRequired.<CommandSource, DoubleCoordinates>argument("position", ArgumentTypeVector3d.vec3d())
                         .executes(c -> {
                             CommandSource source = c.getSource();
                             DoubleCoordinates targetCoordinates = c.getArgument("position", DoubleCoordinates.class);
@@ -56,7 +55,7 @@ public class CommandTeleport implements CommandManager.CommandRegistry {
                         return Command.SINGLE_SUCCESS;
                     })
                 )
-                .then(ArgumentBuilderRequired.<CommandSource, DoubleCoordinates>argument("position", ArgumentTypeVec3.vec3d())
+                .then(ArgumentBuilderRequired.<CommandSource, DoubleCoordinates>argument("position", ArgumentTypeVector3d.vec3d())
                         .executes(c -> {
                             CommandSource source = c.getSource();
                             DoubleCoordinates targetCoordinates = c.getArgument("position", DoubleCoordinates.class);
@@ -71,7 +70,7 @@ public class CommandTeleport implements CommandManager.CommandRegistry {
                             return Command.SINGLE_SUCCESS;
                         }))
                 .then(ArgumentBuilderRequired.<CommandSource, EntitySelector>argument("entity", ArgumentTypeEntity.entities())
-                        .then(ArgumentBuilderRequired.<CommandSource, DoubleCoordinates>argument("position", ArgumentTypeVec3.vec3d())
+                        .then(ArgumentBuilderRequired.<CommandSource, DoubleCoordinates>argument("position", ArgumentTypeVector3d.vec3d())
                                 .executes(c -> {
                                     CommandSource source = c.getSource();
                                     EntitySelector entitySelector = c.getArgument("entity", EntitySelector.class);
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/helpers/Coordinates2D.java b/game/core/src/main/java/net/minecraft/core/net/command/helpers/Coordinates2D.java
index f435adaea..1394462c1 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/helpers/Coordinates2D.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/helpers/Coordinates2D.java
@@ -2,16 +2,17 @@ package net.minecraft.core.net.command.helpers;
 
 import com.mojang.brigadier.exceptions.CommandSyntaxException;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.exceptions.CommandExceptions;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3dc;
 
 public class Coordinates2D {
-    private final IntegerCoordinate x;
-    private final IntegerCoordinate z;
+    private final @NotNull IntegerCoordinate x;
+    private final @NotNull IntegerCoordinate z;
 
-    public Coordinates2D(IntegerCoordinate x, IntegerCoordinate z) {
+    public Coordinates2D(@NotNull IntegerCoordinate x, @NotNull IntegerCoordinate z) {
         this.x = x;
         this.z = z;
     }
@@ -37,7 +38,7 @@ public class Coordinates2D {
     }
 
     public int getX(CommandSource source) throws CommandSyntaxException {
-        Vec3 sourceCoordinates = source.getCoordinates(true);
+        Vector3dc sourceCoordinates = source.getCoordinates(true);
         if (sourceCoordinates == null) {
             if (!this.x.isRelative()) {
                 return this.x.get(0);
@@ -45,11 +46,11 @@ public class Coordinates2D {
                 throw CommandExceptions.notInWorld().create();
             }
         }
-        return this.x.get(MathHelper.floor(sourceCoordinates.x / 16.0));
+        return this.x.get(MathHelper.floor(sourceCoordinates.x() / 16.0));
     }
 
     public int getZ(CommandSource source) throws CommandSyntaxException {
-        Vec3 sourceCoordinates = source.getCoordinates(true);
+        Vector3dc sourceCoordinates = source.getCoordinates(true);
         if (sourceCoordinates == null) {
             if (!this.z.isRelative()) {
                 return this.z.get(0);
@@ -57,7 +58,7 @@ public class Coordinates2D {
                 throw CommandExceptions.notInWorld().create();
             }
         }
-        return this.z.get(MathHelper.floor(sourceCoordinates.z / 16.0));
+        return this.z.get(MathHelper.floor(sourceCoordinates.z() / 16.0));
     }
 
     public boolean hasRelativeCoordinate() {
